Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Selectors/IMatchSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Selectors/IMatchSelector.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Selectors/IMatchSelector.cs	(revision 9089)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  public interface IMatchSelector : IOperator, IParameterizedNamedItem, INamedItem, IParameterizedItem, IItem, IContent, IDeepCloneable, ICloneable {
+    BoolValue CopySelected { get; set; }
+    BoolValue MatchCondition { get; set; }
+    IValueLookupParameter<IntValue> NumberOfSelectedSubScopesParameter { get; }
+    ILookupParameter<IClassifier> TargetMatchParameter { get; }
+    ILookupParameter<ItemArray<IClassifier>> MatchParameter { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Selectors/MatchSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Selectors/MatchSelector.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Selectors/MatchSelector.cs	(revision 9089)
@@ -0,0 +1,102 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Selection;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  /// <summary>
+  /// A class for selection operators which match a target to the scopes.
+  /// </summary>
+  [Item("MatchSelector", "A class for selection operators which match a target to the scopes.")]
+  [StorableClass]
+  public class MatchSelector : Selector, IMatchSelector {
+    protected IValueParameter<BoolValue> CopySelectedParameter {
+      get { return (IValueParameter<BoolValue>)Parameters["CopySelected"]; }
+    }
+    protected IValueParameter<BoolValue> MatchConditionParameter {
+      get { return (IValueParameter<BoolValue>)Parameters["MatchCondition"]; }
+    }
+    public IValueLookupParameter<IntValue> NumberOfSelectedSubScopesParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["NumberOfSelectedSubScopes"]; }
+    }
+    public ILookupParameter<IClassifier> TargetMatchParameter {
+      get { return (ILookupParameter<IClassifier>)Parameters["TargetMatchParameter"]; }
+    }
+    public ILookupParameter<ItemArray<IClassifier>> MatchParameter {
+      get { return (ILookupParameter<ItemArray<IClassifier>>)Parameters["MatchParameter"]; }
+    }
+    public BoolValue CopySelected {
+      get { return CopySelectedParameter.Value; }
+      set { CopySelectedParameter.Value = value; }
+    }
+
+    public BoolValue MatchCondition {
+      get { return MatchConditionParameter.Value; }
+      set { MatchConditionParameter.Value = value; }
+    }
+
+    [StorableConstructor]
+    protected MatchSelector(bool deserializing) : base(deserializing) { }
+    protected MatchSelector(MatchSelector original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MatchSelector(this, cloner);
+    }
+
+    public MatchSelector()
+      : base() {
+      Parameters.Add(new ValueParameter<BoolValue>("CopySelected", "True if the selected sub-scopes should be copied, otherwise false.", new BoolValue(true)));
+      Parameters.Add(new ValueParameter<BoolValue>("MatchCondition", "True if the condition of the match paramteres have to match, otherwise the action has to match.", new BoolValue(true)));
+      Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfSelectedSubScopes", "The number of sub-scopes which should be selected."));
+      Parameters.Add(new ValueLookupParameter<IClassifier>("TargetMatchParameter", "Target that has to be matched by the match parameter."));
+      Parameters.Add(new ScopeTreeLookupParameter<IClassifier>("MatchParameter", "The matching encoding contained in each sub-scope which is used for selection."));
+    }
+
+    protected override IScope[] Select(List<IScope> scopes) {
+      IClassifier target = TargetMatchParameter.ActualValue;
+      List<IScope> matched = new List<IScope>();
+      for (int i = 0; i < MatchParameter.ActualValue.Length; i++) {
+        if (MatchingMethod(MatchParameter.ActualValue[i], target)) {
+          if (CopySelected.Value) {
+            matched.Add((IScope)scopes[i].Clone());
+          } else {
+            matched.Add(scopes[i]);
+          }
+        }
+      }
+      NumberOfSelectedSubScopesParameter.ActualValue = new IntValue(matched.Count);
+      return matched.ToArray();
+    }
+
+    private bool MatchingMethod(IClassifier iMatching, IClassifier target) {
+      if (MatchCondition.Value) {
+        return iMatching.MatchCondition(target);
+      } else {
+        return iMatching.MatchAction(target);
+      }
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/HeuristicLab.Problems.ConditionActionClassification-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/HeuristicLab.Problems.ConditionActionClassification-3.3.csproj	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/HeuristicLab.Problems.ConditionActionClassification-3.3.csproj	(revision 9089)
@@ -0,0 +1,103 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>8.0.30703</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{EA51D441-F6A3-41E1-9993-A2488E93C222}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Problems.ConditionActionClassification</RootNamespace>
+    <AssemblyName>HeuristicLab.Problems.ConditionActionClassification-3.3</AssemblyName>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="HeuristicLab.Collections-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Collections-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Common-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Core-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Data-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Data-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Encodings.IntegerVectorEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Operators-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Optimization-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Parameters-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Parameters-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Persistence-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Problems.DataAnalysis-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Implementation\ConditionActionClassificationProblem.cs" />
+    <Compile Include="Implementation\ConditionActionClassificationProblemData.cs" />
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Reinforcement\CombinedIntegerVectorClassifierFetcher.cs" />
+    <None Include="HeuristicLab.snk" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="Plugin.cs.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.CombinedIntegerVectorEncoding\3.3\HeuristicLab.Encodings.CombinedIntegerVectorEncoding-3.3.csproj">
+      <Project>{CE7163C5-BFFE-45F0-9BD0-E10EF24E8BD2}</Project>
+      <Name>HeuristicLab.Encodings.CombinedIntegerVectorEncoding-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.ConditionActionEncoding\3.3\HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj">
+      <Project>{422FB262-0845-4969-8D16-12F057AA90B1}</Project>
+      <Name>HeuristicLab.Encodings.ConditionActionEncoding-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblem.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblem.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblem.cs	(revision 9089)
@@ -0,0 +1,236 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.CombinedIntegerVectorEncoding;
+using HeuristicLab.Encodings.ConditionActionEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Problems.ConditionActionClassification {
+  [StorableClass]
+  public class ConditionActionClassificationProblem : HeuristicOptimizationProblem<XCSEvaluator, UniformRandomCombinedIntegerVectorCreator>, IConditionActionProblem {
+    private const string ClassifierFetcherParameterName = "ClassifierFetcher";
+    private const string ActionExecuterParameterName = "ActionExecuter";
+
+    IXCSEvaluator IConditionActionProblem.Evaluator {
+      get { return Evaluator; }
+    }
+
+    #region parameter properties
+    public IValueParameter<ConditionActionClassificationProblemData> ProblemDataParameter {
+      get { return (IValueParameter<ConditionActionClassificationProblemData>)Parameters["ProblemData"]; }
+    }
+    public IFixedValueParameter<DoubleValue> PositiveRewardParameter {
+      get { return (IFixedValueParameter<DoubleValue>)Parameters["PositiveReward"]; }
+    }
+    public IFixedValueParameter<DoubleValue> NegativeRewardParameter {
+      get { return (IFixedValueParameter<DoubleValue>)Parameters["NegativeReward"]; }
+    }
+    public IFixedValueParameter<DoubleValue> InitialPredictionParameter {
+      get { return (IFixedValueParameter<DoubleValue>)Parameters["InitialPrediction"]; }
+    }
+    public IFixedValueParameter<DoubleValue> InitialErrorParameter {
+      get { return (IFixedValueParameter<DoubleValue>)Parameters["InitialError"]; }
+    }
+    public IFixedValueParameter<DoubleValue> InitialFitnessParameter {
+      get { return (IFixedValueParameter<DoubleValue>)Parameters["InitialFitness"]; }
+    }
+    public IFixedValueParameter<IItemSet<IClassifier>> PossibleActionsParameter {
+      get { return (IFixedValueParameter<IItemSet<IClassifier>>)Parameters["PossibleActions"]; }
+    }
+    private IFixedValueParameter<IntValue> ThetaMinimalNumberOfActionsParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters["ThetaMinimalNumberOfActions"]; }
+    }
+    //for test purposes
+    public IFixedValueParameter<IntValue> LengthParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters["Length"]; }
+    }
+    public IFixedValueParameter<IntValue> ActionPartLengthParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters["ActionPartLength"]; }
+    }
+    public IFixedValueParameter<IntMatrix> BoundsParameter {
+      get { return (IFixedValueParameter<IntMatrix>)Parameters["Bounds"]; }
+    }
+    #endregion
+
+    #region properties
+    IParameter IConditionActionProblem.ProblemDataParameter {
+      get { return ProblemDataParameter; }
+    }
+    IConditionActionProblemData IConditionActionProblem.ProblemData {
+      get { return ProblemData; }
+    }
+    public ConditionActionClassificationProblemData ProblemData {
+      get { return ProblemDataParameter.Value; }
+    }
+    IParameter IConditionActionProblem.PossibleActionsParameter {
+      get { return PossibleActionsParameter; }
+    }
+    IItemSet<IClassifier> IConditionActionProblem.PossibleActions {
+      get { return PossibleActions; }
+    }
+    public IItemSet<IClassifier> PossibleActions {
+      get { return PossibleActionsParameter.Value; }
+    }
+    public IActionExecuter ActionExecuter {
+      get { return ActionExecuterParameter.Value; }
+    }
+    public ValueParameter<IActionExecuter> ActionExecuterParameter {
+      get { return (ValueParameter<IActionExecuter>)Parameters[ActionExecuterParameterName]; }
+    }
+    IParameter IConditionActionProblem.ActionExecuterParameter { get { return ActionExecuterParameter; } }
+    public CombinedIntegerVectorClassifierFetcher ClassifierFetcher {
+      get { return ClassifierFetcherParameter.Value; }
+    }
+    public ValueParameter<CombinedIntegerVectorClassifierFetcher> ClassifierFetcherParameter {
+      get { return (ValueParameter<CombinedIntegerVectorClassifierFetcher>)Parameters[ClassifierFetcherParameterName]; }
+    }
+    IClassifierFetcher IConditionActionProblem.ClassifierFetcher { get { return ClassifierFetcher; } }
+    IParameter IConditionActionProblem.ClassifierFetcherParameter { get { return ClassifierFetcherParameter; } }
+
+    private IntValue ThetaMinimalNumberOfActions {
+      get { return ThetaMinimalNumberOfActionsParameter.Value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected ConditionActionClassificationProblem(bool deserializing) : base(deserializing) { }
+    protected ConditionActionClassificationProblem(ConditionActionClassificationProblem original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ConditionActionClassificationProblem(this, cloner);
+    }
+
+    public ConditionActionClassificationProblem() :
+      this(new ConditionActionClassificationProblemData(new Dataset(ConditionActionClassificationProblemData.defaultVariableNames, ConditionActionClassificationProblemData.defaultData),
+        ConditionActionClassificationProblemData.defaultVariableNames.Take(ConditionActionClassificationProblemData.defaultVariableNames.Length - 1), ConditionActionClassificationProblemData.defaultVariableNames.Last().ToEnumerable()),
+        new XCSEvaluator(), new UniformRandomCombinedIntegerVectorCreator()) {
+    }
+
+    public ConditionActionClassificationProblem(ConditionActionClassificationProblemData problemData, XCSEvaluator evaluator, UniformRandomCombinedIntegerVectorCreator solutionCreator)
+      : base(evaluator, solutionCreator) {
+      Parameters.Add(new FixedValueParameter<IntValue>("Length", "The operator to create a solution.", new IntValue(7)));
+      Parameters.Add(new FixedValueParameter<IntValue>("ActionPartLength", "The operator to create a solution.", new IntValue(1)));
+      int[,] elements = new int[,] { { 0, 3 }, { 0, 3 }, { 0, 3 }, { 0, 3 }, { 0, 3 }, { 0, 3 }, { 0, 2 } };
+      Parameters.Add(new FixedValueParameter<IntMatrix>("Bounds", "The operator to create a solution.", new IntMatrix(elements)));
+      Parameters.Add(new ValueParameter<ConditionActionClassificationProblemData>("ProblemData", "", problemData));
+      Parameters.Add(new FixedValueParameter<DoubleValue>("PositiveReward", "", new DoubleValue(1000)));
+      Parameters.Add(new FixedValueParameter<DoubleValue>("NegativeReward", "", new DoubleValue(0)));
+      Parameters.Add(new FixedValueParameter<DoubleValue>("InitialPrediction", "Initial Presiction", new DoubleValue(0)));
+      Parameters.Add(new FixedValueParameter<DoubleValue>("InitialError", "Initial Error", new DoubleValue(0)));
+      Parameters.Add(new FixedValueParameter<DoubleValue>("InitialFitness", "Initial Fitness", new DoubleValue(0)));
+
+      Parameters.Add(new ValueParameter<IActionExecuter>(ActionExecuterParameterName, "", new ActionExecuter()));
+      Parameters.Add(new ValueParameter<CombinedIntegerVectorClassifierFetcher>(ClassifierFetcherParameterName, "", new CombinedIntegerVectorClassifierFetcher()));
+      Parameters.Add(new FixedValueParameter<ItemSet<IClassifier>>("PossibleActions"));
+      Parameters.Add(new FixedValueParameter<IntValue>("ThetaMinimalNumberOfActions", "Minimal number of actions, which have to be present in the match set, or else covering will occure."));
+
+      Evaluator.InitialErrorParameter.ActualName = "InitialError";
+      Evaluator.InitialFitnessParameter.ActualName = "InitialFitness";
+      Evaluator.InitialPredictionParameter.ActualName = "InitialPrediction";
+
+      SolutionCreator.ActionPartLengthParameter.ActualName = ActionPartLengthParameter.Name;
+      SolutionCreator.LengthParameter.ActualName = LengthParameter.Name;
+      SolutionCreator.BoundsParameter.ActualName = BoundsParameter.Name;
+
+      ClassifierFetcher.ActionPartLengthParameter.ActualName = ActionPartLengthParameter.Name;
+      ClassifierFetcher.BoundsParameter.ActualName = BoundsParameter.Name;
+      ClassifierFetcher.ProblemDataParameter.ActualName = ProblemDataParameter.Name;
+
+      ActionExecuter.CurrentClassifierToMatchParameter.ActualName = ClassifierFetcher.CurrentClassifierToMatchParameter.ActualName;
+      ActionExecuter.NegativeRewardParameter.ActualName = NegativeRewardParameter.Name;
+      ActionExecuter.PositiveRewardParameter.ActualName = PositiveRewardParameter.Name;
+
+      SetPossibleActions();
+      ThetaMinimalNumberOfActions.Value = PossibleActions.Count;
+
+      BoundsParameter.ValueChanged += new System.EventHandler(BoundsParameter_ValueChanged);
+      LengthParameter.ValueChanged += new System.EventHandler(LengthParameter_ValueChanged);
+      ActionPartLengthParameter.ValueChanged += new System.EventHandler(ActionPartLengthParameter_ValueChanged);
+    }
+
+    #region event handler
+    private void ActionPartLengthParameter_ValueChanged(object sender, System.EventArgs e) {
+      SetPossibleActions();
+    }
+    private void LengthParameter_ValueChanged(object sender, System.EventArgs e) {
+      SetPossibleActions();
+    }
+    private void BoundsParameter_ValueChanged(object sender, System.EventArgs e) {
+      SetPossibleActions();
+    }
+    #endregion
+
+    private void SetPossibleActions() {
+      //get bounds of action
+      IntMatrix actionBounds = GetElementsOfBoundsForAction(BoundsParameter.Value, LengthParameter.Value.Value, ActionPartLengthParameter.Value.Value);
+      int actionLength = ActionPartLengthParameter.Value.Value;
+      int start = LengthParameter.Value.Value - actionLength;
+      int[] elements = new int[actionLength];
+      int[] curPos = new int[actionLength];
+      bool done = false;
+      //initialize curPos
+      for (int i = 0; i < actionBounds.Rows; i++) {
+        curPos[i] = actionBounds[i, 0];
+      }
+      PossibleActions.Clear();
+      while (!done) {
+        PossibleActions.Add(new CombinedIntegerVector(curPos, actionLength, actionBounds));
+        curPos = GetNextAction(curPos, actionBounds, out done);
+      }
+
+    }
+
+    private int[] GetNextAction(int[] curPos, IntMatrix actionBounds, out bool done) {
+      int cur = 0;
+      while (cur < curPos.Length) {
+        curPos[cur] += actionBounds.Columns < 3 ? 1 : actionBounds[cur, 2];
+        if (curPos[cur] >= actionBounds[cur, 1]) {
+          curPos[cur] = actionBounds[cur, 0];
+          cur++;
+        } else {
+          break;
+        }
+      }
+      done = cur >= curPos.Length;
+      return curPos;
+    }
+
+    private IntMatrix GetElementsOfBoundsForAction(IntMatrix bounds, int length, int actionPartLength) {
+      IntMatrix actionBounds = new IntMatrix(actionPartLength, bounds.Columns);
+      int start = length - actionPartLength;
+      for (int i = start; i < length; i++) {
+        int pos = i % bounds.Rows;
+        for (int j = 0; j < bounds.Columns; j++) {
+          actionBounds[i - start, j] = bounds[pos, j];
+        }
+      }
+      return actionBounds;
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblemData.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblemData.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblemData.cs	(revision 9089)
@@ -0,0 +1,111 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ConditionActionEncoding;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Problems.ConditionActionClassification {
+  public class ConditionActionClassificationProblemData : ParameterizedNamedItem, IConditionActionProblemData {
+
+    #region default data
+    public static string[] defaultVariableNames = new string[] { "a", "b", "c", "d", "e", "f", "g" };
+    public static double[,] defaultData = new double[,]{
+      {0,0,1,1,0,0,0},
+      {0,1,1,1,0,0,0},
+      {0,0,1,0,0,0,0},
+      {1,0,1,0,1,1,0}
+    };
+    #endregion
+
+    #region parameter properites
+    public IFixedValueParameter<Dataset> DatasetParameter {
+      get { return (IFixedValueParameter<Dataset>)Parameters["Dataset"]; }
+    }
+    public IFixedValueParameter<ReadOnlyCheckedItemList<StringValue>> ConditionVariablesParameter {
+      get { return (IFixedValueParameter<ReadOnlyCheckedItemList<StringValue>>)Parameters["ConditionVariables"]; }
+    }
+    public IFixedValueParameter<ReadOnlyCheckedItemList<StringValue>> ActionVariablesParameter {
+      get { return (IFixedValueParameter<ReadOnlyCheckedItemList<StringValue>>)Parameters["ActionVariables"]; }
+    }
+    #endregion
+
+    public Dataset Dataset {
+      get { return DatasetParameter.Value; }
+    }
+
+    public ICheckedItemList<StringValue> ConditionVariables {
+      get { return ConditionVariablesParameter.Value; }
+    }
+
+    public ICheckedItemList<StringValue> ActionVariables {
+      get { return ActionVariablesParameter.Value; }
+    }
+
+    public IEnumerable<string> AllowedConditionVariables {
+      get { return ConditionVariables.CheckedItems.Select(x => x.Value.Value); }
+    }
+    public IEnumerable<string> AllowedActionVariables {
+      get { return ActionVariables.CheckedItems.Select(x => x.Value.Value); }
+    }
+
+
+    [StorableConstructor]
+    protected ConditionActionClassificationProblemData(bool deserializing) : base(deserializing) { }
+    protected ConditionActionClassificationProblemData(ConditionActionClassificationProblemData original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ConditionActionClassificationProblemData(this, cloner);
+    }
+
+    public ConditionActionClassificationProblemData(Dataset dataset, IEnumerable<string> allowedConditionVariables, IEnumerable<string> allowedActionVariables) {
+      if (dataset == null) throw new ArgumentNullException("The dataset must not be null.");
+      if (allowedActionVariables == null) throw new ArgumentNullException("The allowedActionVariables must not be null.");
+      if (allowedConditionVariables == null) throw new ArgumentNullException("The allowedActionVariables must not be null.");
+
+      if (allowedActionVariables.Except(dataset.DoubleVariables).Any())
+        throw new ArgumentException("All allowed action variables must be present in the dataset and of type double.");
+      if (allowedConditionVariables.Except(dataset.DoubleVariables).Any())
+        throw new ArgumentException("All allowed condition variables must be present in the dataset and of type double.");
+
+      var actionVariables = new CheckedItemList<StringValue>(dataset.DoubleVariables.Select(x => new StringValue(x)));
+      var conditionVariables = new CheckedItemList<StringValue>(actionVariables);
+      foreach (StringValue x in actionVariables) {
+        actionVariables.SetItemCheckedState(x, allowedActionVariables.Contains(x.Value));
+        conditionVariables.SetItemCheckedState(x, allowedConditionVariables.Contains(x.Value));
+      }
+
+      Parameters.Add(new FixedValueParameter<Dataset>("Dataset", "", dataset));
+      Parameters.Add(new FixedValueParameter<ReadOnlyCheckedItemList<StringValue>>("ActionVariables", "", actionVariables.AsReadOnly()));
+      Parameters.Add(new FixedValueParameter<ReadOnlyCheckedItemList<StringValue>>("ConditionVariables", "", conditionVariables.AsReadOnly()));
+
+      ((ValueParameter<Dataset>)DatasetParameter).ReactOnValueToStringChangedAndValueItemImageChanged = false;
+    }
+  }
+}
